(**************************************************************)
(*   The Strong Completeness of Partial Monoidal Boolean BI   *)
(*   Copyright Dominique Larchey-Wendling [*]                 *)
(*                                                            *)
(*                             [*] Affiliation LORIA -- CNRS  *)
(**************************************************************)
(*      This file is distributed under the terms of the       *)
(*         CeCILL v2 FREE SOFTWARE LICENSE AGREEMENT          *)
(**************************************************************)

Require Import List.

Require Import maps.

Require Import css.
Require Import enum.
Require Import enumerations.

Definition fair_strategy (f : nat -> stm) := i_surjective f.

Proposition fair_strategy_exists : { f | fair_strategy f }.
Proof.
  generalize (enumeration_surj _ enum_stm); intros H.
  destruct enum_stm; simpl in H.
  exists (fun x => enum_dmap (nat_repeat x)).
  apply comp_isurj_surj.
  apply nat_repeat_isurj.
  auto.
Qed.
